using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace WindowsApplication1
{
    public partial class Form1 : Form
    {
        DataTable table1 = new DataTable();
        DataTable table2 = new DataTable();
        DataTable table3 = new DataTable();

        DataSet tables = new DataSet();

        public Form1()
        {
            InitializeComponent();
        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {

            GridEngine engine = new GridEngine();

            engine.TableDescriptor.ChildGroupOptions.CaptionText = "{CategoryCaption}: {Category}";
            engine.TopLevelGroupOptions.ShowCaption = false;
            engine.TableDescriptor.AllowNew = false;
            gridGroupingControl1.Engine = engine;
            gridGroupingControl1.ShowGroupDropArea = true;
            gridGroupingControl1.NestedTableGroupOptions.ShowAddNewRecordBeforeDetails = false;

            
            #region Fill table 1
            table1.Columns.Add("ID", typeof(int));
            table1.Columns.Add("Text", typeof(string));
            table1.Columns.Add("Whatever", typeof(string));

            
            for (int i = 0; i < 5; i++)
            {
                DataRow tempRow = table1.NewRow();
                tempRow[0] = i;
                tempRow[1] = "Text_" + i.ToString();
                tempRow[2] = "Whatever_" + i.ToString();
                table1.Rows.Add(tempRow);
            }
            #endregion

            #region Fill table 2
            table2.Columns.Add("Table1_ID", typeof(int));
            table2.Columns.Add("Foreign key", typeof(string));
            table2.Columns.Add("Nothing much", typeof(string));
            
            for (int i = 0; i < 10; i++)
            {
                DataRow tempRow = table2.NewRow();
                if ((i / 2) >= 1 )
                {
                    tempRow[0] = i/2;
                }
                else tempRow[0] = i;

                tempRow[1] = i.ToString();
                table2.Rows.Add(tempRow);
            }
            #endregion           

            #region Fill table 3
            table3.Columns.Add("PK", typeof(string));
            table3.Columns.Add("Note", typeof(string));
            table3.Columns.Add("Something else", typeof(string));
            table3.Columns.Add("More stuff", typeof(string));


            for (int i = 0; i < 21 ; i++)
            {
                DataRow tempRow = table3.NewRow();
                if (i / 3 >= 1)
                {
                    tempRow[0] = i/3;
                }
                else tempRow[0] = i.ToString();

                tempRow[1] = "Note";
                tempRow[2] = "Something else " + i.ToString();
                tempRow[3] = "More stuff " + (i/2).ToString();              
                
                table3.Rows.Add(tempRow);
            }
            #endregion


            tables.Tables.Add(table1);
            tables.Tables.Add(table2);
            tables.Tables.Add(table3);

            DataRelation rel1 = new DataRelation("rel 1", table1.Columns[0], table2.Columns[0], false);
            DataRelation rel2 = new DataRelation("rel 2", table2.Columns[1], table3.Columns[0],false);

            tables.Relations.Add(rel1);
            tables.Relations.Add(rel2);

            gridGroupingControl1.DataSource = table1;

            // How can I remove the "More stuff" fom visible columns?
            // or change the header text of "Nothin much" column?
            // or change text of table3 caption to say "3d table"

            // what I need is acces to table descriptor of every nested table

        }
    }
}